# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetIpResult',
    'AwaitableGetIpResult',
    'get_ip',
    'get_ip_output',
]

@pulumi.output_type
class GetIpResult:
    """
    A collection of values returned by getIp.
    """
    def __init__(__self__, address=None, app=None, id=None, region=None, type=None):
        if address and not isinstance(address, str):
            raise TypeError("Expected argument 'address' to be a str")
        pulumi.set(__self__, "address", address)
        if app and not isinstance(app, str):
            raise TypeError("Expected argument 'app' to be a str")
        pulumi.set(__self__, "app", app)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def address(self) -> str:
        """
        Empty if using `shared_v4`
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter
    def app(self) -> str:
        """
        The App this resource will be created in
        """
        return pulumi.get(self, "app")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        A fly-generated ID
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def region(self) -> str:
        """
        Fly region, ex `ord`, `sin`, `mad`
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        `v4`, `v6`, or `private_v6`
        """
        return pulumi.get(self, "type")


class AwaitableGetIpResult(GetIpResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetIpResult(
            address=self.address,
            app=self.app,
            id=self.id,
            region=self.region,
            type=self.type)


def get_ip(app: Optional[str] = None,
           id: Optional[str] = None,
           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetIpResult:
    """
    Use this data source to access information about an existing resource.

    :param str app: The App this resource will be created in
    :param str id: A fly-generated ID
    """
    __args__ = dict()
    __args__['app'] = app
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('fly:index/getIp:getIp', __args__, opts=opts, typ=GetIpResult).value

    return AwaitableGetIpResult(
        address=pulumi.get(__ret__, 'address'),
        app=pulumi.get(__ret__, 'app'),
        id=pulumi.get(__ret__, 'id'),
        region=pulumi.get(__ret__, 'region'),
        type=pulumi.get(__ret__, 'type'))


@_utilities.lift_output_func(get_ip)
def get_ip_output(app: Optional[pulumi.Input[str]] = None,
                  id: Optional[pulumi.Input[str]] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetIpResult]:
    """
    Use this data source to access information about an existing resource.

    :param str app: The App this resource will be created in
    :param str id: A fly-generated ID
    """
    ...
